<template>
    <transition name="modal">
        <modal>
            <div slot="header">
                <button type="button" class="close" data-dismiss="modal" @click="$emit('close')">
                    <span aria-hidden="true">×</span><span class="sr-only">Close</span>
                </button>
                <h4 class="modal-title">
                    Post Credit Note (Sales Return) -
                    <span>Invoice #{{ invoice.bill_no }}</span>
                </h4>
            </div>

            <div slot="body">
                <div class="form-horizontal group-border">

                    <div class="form-group">
                        <label class="col-md-4 control-label" for="credit_note_number">Credit Note Number: <span class="required">*</span></label>
                        <div class="col-md-8">
                            <input type="text" class="dotted-field" id="credit_note_number" v-model="credit_note_number">
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-4 control-label" for="credit_note_date_ad">Credit Note Date: <span class="required">*</span></label>
                        <div class="col-md-8 datepicker">
                            <span class="help-text">AD: </span>
                            <english-date-picker id="credit_note_date_ad" uniqueid="credit_note_date" v-model="credit_note_date.ad" class="dotted-field date-field date-ad"/>
                            <span class="help-text">(BS: </span>
                            <nepali-date-picker id="credit_note_date_bs" uniqueid="credit_note_date" v-model="credit_note_date.bs" class="dotted-field date-field date-bs"/>
                            <span class="help-text">)</span>
                        </div>
                    </div>

                    <div class="form-group">
                        <label class="col-md-4 control-label" for="reason_for_return">Reason for return: <span class="required">*</span></label>
                        <div class="col-md-8">
                            <div>
                                <textarea class="dotted-field" id="reason_for_return" v-model="reason_for_return" name="default"></textarea>
                            </div>
                        </div>
                    </div>

                </div>
                <div class="clearfix"></div>
            </div>

            <div slot="footer">
                <button type="button" class="btn btn-danger" @click.prevent="proceedCancellation">Cancel Invoice</button>
            </div>
        </modal>
    </transition>
</template>

<script type="text/ecmascript-6">
    import Modal             from "./../../components/Modal";
    import EnglishDatePicker from "./../../components/EnglishDatePicker";
    import NepaliDatePicker  from "./../../components/NepaliDatePicker";
    import moment            from "moment";
    import axios             from "axios";

    export default {
        name: "InvoiceCancelForm",

        components: {
            modal: Modal,
            "english-date-picker": EnglishDatePicker,
            "nepali-date-picker": NepaliDatePicker,
        },

        props: {
            invoice: {required: true, type: Object},
            apiCreditNoteNumber: {required: true, type: String},
            apiCancellation: {required: true, type: String},
        },

        data() {
            return {
                credit_note_number: 0,
                credit_note_date: {
                    ad: moment().format("YYYY-MM-DD"),
                    bs: "",
                },
                reason_for_return: "",
            };
        },

        computed: {
            cancelledData: function() {
                return {
                    credit_note_number: this.credit_note_number,
                    credit_note_date_ad: this.credit_note_date.ad,
                    credit_note_date_bs: this.credit_note_date.bs,
                    reason_for_return: this.reason_for_return,
                };
            },
        },

        mounted() {
            this.getCreditNoteNumber();
        },

        methods: {
            getCreditNoteNumber() {
                axios.get(this.apiCreditNoteNumber, {params: {date: this.credit_note_date.ad}}).then(response => {
                    this.credit_note_number = response.data.data;
                });
            },

            proceedCancellation() {
                axios.post(this.apiCancellation, this.cancelledData).then(response => {
                    if (response.data.success) {
                        window.location.href = response.data.data.redirect_url;
                    }
                });
            },
        },
    };
</script>

<style scoped>
    .dotted-field {
        margin: 8px 5px;
    }

    textarea.dotted-field {
        width: 100%;
        resize: none;
        min-height: 50px;
    }

    #invoice-app .invoice .datepicker {
        display: flex
    }

    #invoice-app .invoice .datepicker span.help-text {
        margin: 10px 0;
    }
</style>
